/*
 * alf.h
 *
 * Description of this file:
 *    ALF functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_ALF_H__
#define __XRD_ALF_H__


int  alf_get_buffer_size(xrd_param_t *param);

void alf_init_buffer(xrd_t *h, uint8_t *mem_base);

void alf_filter_one_frame(xrd_t *h);

void alf_get_statistics_lcu(xrd_t *h, int lcu_x, int lcu_y,
                            xrd_frame_t *p_org, xrd_frame_t *p_rec);

#endif  // __XRD_ALF_H__
