/*
 * header.h
 *
 * Description of this file:
 *    Header writing functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_HEADER_H__
#define __XRD_HEADER_H__

int  xrd_sequence_write(xrd_t *h, bs_t *p_bs);
int  xrd_user_data_write(bs_t *p_bs);
int  xrd_intra_picture_header_write(xrd_t *h, bs_t *p_bs);
int  xrd_inter_picture_header_write(xrd_t *h, bs_t *p_bs);
void xrd_picture_header_alf_write(xrd_t *h, ALFParam *alfPictureParam, bs_t *p_bs);
int  xrd_slice_header_write(xrd_t *h, slice_t *p_slice);

#endif  // __XRD_HEADER_H__
