/*
 * ratecontrol.h
 *
 * Description of this file:
 *    Ratecontrol functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_RATECONTRAL_H__
#define __XRD_RATECONTRAL_H__

int  xrd_rc_get_buffer_size(xrd_param_t *h);
int  xrd_ratecontrol_init(ratectrl_t *rc, xrd_param_t *param);

int  xrd_ratecontrol_base_qp(xrd_t *h);

int  xrd_ratecontrol_qp(xrd_t *h, int frm_idx, int frm_type, int force_qp);
int  xrd_ratecontrol_qp_lcu(xrd_t *h, int frm_idx, int qp);

void xrd_ratecontrol_end(xrd_t *h, int frm_bits, int frm_qp, int frm_type, int frm_idx);

void xrd_ratecontrol_end_lcu(xrd_t *h, int frm_idx, int qp);

void xrd_ratecontrol_destroy(ratectrl_t *rc);

#endif  // __XRD_RATECONTRAL_H__
